(       ASSEMBLER FOR THE ARM, VERSION T.2 FOR IPS-M        )
(             {c} KARL MEINZER 02.11.1997                   )
( Note that mnemonics and syntax are still subject to change)

(  Mods to CODE and NEXT                    jrm 1997 Dec 06 )
(  Edit to  $statprep                       km  1998 Jan 02 )
(  Additional useful words appended                         )

( VAR AND FLAGS )
#E000 var $ucf    ( UPPER CODE FRAGMENT )
    0 var $lcf    ( LOWER CODE FRAGMENT )
    0 var $afrs   ( ASSEMBLER FLAG REGISTER SHIFT )
    0 var $afam   ( ASSEMBLER FLAG ADDRESS MODE )

( ERROR MESSAGES AND HANDLING )
16 feld $agem  ~ ARGUMENT ERROR!  ~   $agem !t
16 feld $npem  ~ NONPERMISSIBLE!  ~   $npem !t
16 feld $icem  ~ INVALID CNDX!    ~   $icem !t
16 feld $aiem  ~ ADDRESS INVALID! ~   $aiem !t
:n $awr   sysline 32 +n 16 >>>n 0 ie ;n

:n <ag>  $agem $awr ;n
:n <np>  $npem $awr ;n
:n <ce>  $icem $awr ;n
:n <ai>  $aiem $awr ;n

:n ^!n dup @n rdo oder vert !n ;n

( AM1 LOWER BUILD, SOME ALSO FOR AM2 )
:n $shpre rdu ( shiftcode , Rm , n or 2*Rs )
         dup 32 <n zwo $afrs @n nicht und oder
         ja? 128 *n rdo oder $afrs @n #10 *n oder zwo 16 <n
             ja? oder $lcf !n  1 $afam !n
                $afrs @n 1 exo dup +n $afrs !n ( R-IM-SHIFT: 2 )
             nein: <ag>
             dann
         nein: <ag>
         dann ;n

:n R.IM  dup dup 30 >n rdo oder
        ja? <ag>
        nein: vert dup #FF00 und =0n ( r , n , cond. )
              ja? vert 128 *n +n $lcf !n #0200 $ucf ^!n
                  1 $afam !n
              nein: <ag>
              dann
        dann ;n

:n IM   0 R.IM ;n
:n RSS  2 *n 1 $afrs !n ;n

( SHIFT-SPECIFIERS )
:n LSL   0  $shpre ;n
:n LSR  #20 $shpre ;n
:n ASR  #40 $shpre ;n
:n ROR  #60 $shpre ;n
:n RRX      0 ROR  ;n
:n NS       0 LSL  ;n
( INSTR. MODIFIERS )
:n ~F  $afam @n 1 =n ja? #10 $ucf ^!n
                  nein: <np>
                  dann ;n

:n $cndxtst  dup #FFF und #555 =n
            ja? #F000 und $ucf !n  1
            nein: <ce>             0
            dann ;n

( AM2 LOWER BUILD )
( Format immediate: Rn  n  <ADR2>  Rd  <Instr> )
( Format register im. shift:                   )
( Rn  Rm  n <shift-specifier> <ADR2> Rd <Instr> )

:n $a2spre  ( REG. IM SHIFT ) $afrs @n 2 =n
           ja? $ucf ^!n 2 $afam !n
           nein: <ai>
           dann ;n

:n $a2ipre  ( 12 BIT IM ) zwo 4096 <n
           ja? $ucf ^!n $lcf !n  2 $afam !n
           nein: <ag>
           dann ;n

( AM2 SPECIFIERS )
:n [+]    #580 $a2ipre ;n       :n [+R]    #780 $a2spre ;n
:n [-]    #500 $a2ipre ;n       :n [-R]    #700 $a2spre ;n
:n []   0 #580 $a2ipre ;n
:n [+]!   #5A0 $a2ipre ;n       :n [+R]!   #7A0 $a2spre ;n
:n [-]!   #520 $a2ipre ;n       :n [-R]!   #720 $a2spre ;n
:n []+    #480 $a2ipre ;n       :n []+R    #680 $a2spre ;n
:n []-    #400 $a2ipre ;n       :n []-R    #600 $a2spre ;n
:n []+T   #4A0 $a2ipre ;n       :n []+RT   #6A0 $a2spre ;n
:n []-T   #420 $a2ipre ;n       :n []-RT   #620 $a2spre ;n

( BUILDING OF INSTRUCTION CODES )

:n $aflagreset #E000 $ucf !n 0 $lcf !n 0 $afrs !n 0 $afam !n ;n
:n $acdep       $lcf @n $dep $ucf @n $dep $aflagreset ;n

:n $check&dep s>r rdu pdup oder #FFF0 und =0n
           $afam @n r>s =n und
            ja? ( op Rn Rd ) #1000 *n $lcf ^!n
                oder $ucf ^!n $acdep
            nein: <ai>
            dann ;n
:n $am0inst ( Rn Rd opcode ) 0 $check&dep ;n
:n $am1inst ( Rn Rd opcode ) 1 $check&dep ;n
:n $am2inst ( Rn Rd opcode ) 2 $check&dep ;n

( DP-INSTRUCTIONS )
:n AND     #000 $am1inst ;n   :n ~AND  0       #110 $am1inst ;n
:n EOR     #020 $am1inst ;n   :n ~EOR  0       #130 $am1inst ;n
:n SUB     #040 $am1inst ;n   :n ~SUB  0       #150 $am1inst ;n
:n RSB     #060 $am1inst ;n   :n ~ADD  0       #170 $am1inst ;n
:n ADD     #080 $am1inst ;n   :n MOV   0 vert  #1A0 $am1inst ;n
:n ADC     #0A0 $am1inst ;n   :n MVN   0 vert  #1E0 $am1inst ;n
:n SBC     #0C0 $am1inst ;n   :n NOP   0  NS 0 MOV ;n
:n RSC     #0E0 $am1inst ;n
:n ORR     #180 $am1inst ;n
:n BIC     #1C0 $am1inst ;n

( LD/STR INSTRUCTIONS )
:n LDR      #10  $am2inst ;n
:n LDB      #50  $am2inst ;n
:n STR      #00  $am2inst ;n
:n STB      #40  $am2inst ;n

( COMPOSITE INSTRUCTIONS )
:n $mulcode s>r rdu RSS LSL #80 $lcf ^!n r>s vert ;n
:n $swpprep  zwo #FFF0 und $afam !n vert #90 oder $lcf ^!n ;n

:n MUL  ( Rm Rs Rd )      0 vert $mulcode    0 $am1inst ;n
:n MLA  ( Rm Rs Rn Rd )          $mulcode  #20 $am1inst ;n
:n SMUL ( Rm Rs Rdl Rdh )        $mulcode  #C0 $am1inst ;n
:n SMLA ( Rm Rs Rdl Rdh )        $mulcode  #E0 $am1inst ;n
:n SWP  ( Rn Rm Rd )             $swpprep #100 $am0inst ;n
:n SWPB ( Rn Rm Rd )             $swpprep #140 $am0inst ;n

( LOAD MULTIPLE, FORMAT: )
( Rn Register_Mask <adr.Spec.> {SPSR/PRIV} <Instr>  )
:n STM  $afam @n 4 =n
       ja? $lcf !n #F und #800 oder $ucf ^!n $acdep
       nein: <ai>
       dann ;n
:n LDM         #10 $ucf ^!n STM ;n
:n $am4gen   $ucf ^!n 4 $afam !n ;n
:n SPSR/PRIV  #40 $ucf ^!n ;n

( LDM/STM ADR. SPECS )
:n DEC/A    #00  $am4gen ;n
:n DEC/A!   #20  $am4gen ;n
:n DEC/B   #100  $am4gen ;n
:n DEC/B!  #120  $am4gen ;n
:n INC/A    #80  $am4gen ;n
:n INC/A!   #A0  $am4gen ;n
:n INC/B   #180  $am4gen ;n
:n INC/B!  #1A0  $am4gen ;n


( STATUS MOVES )
:n $statprep     0 NS #F vert ;n

:n CP->R ( Rd ) $statprep #100 $am1inst ;n
:n SP->R ( Rd ) $statprep #140 $am1inst ;n
:n ->SP  ( Mask , <sh.op; only Rm NS or n r R.IM> )
        #F #160 $am1inst ;n
:n ->CP  ( Mask , <sh.op; only Rm NS or n r R.IM> )
        #F #120 $am1inst ;n

(  26-BIT-MODE STATUS SETTING )
:n P~AND  #F       #110 $am1inst ;n
:n P~EOR  #F       #130 $am1inst ;n
:n P~SUB  #F       #150 $am1inst ;n
:n P~ADD  #F       #170 $am1inst ;n

( FLOW CONTROL INSTRUCTIONS )

( CNDX-Codes )
:n Z          #0555 ;n            :n NZ        #1555 ;n
:n C          #2555 ;n            :n NC        #3555 ;n
:n NEG        #4555 ;n            :n NNEG      #5555 ;n
:n OF         #6555 ;n            :n NOF       #7555 ;n
:n HI         #8555 ;n            :n LS        #9555 ;n
:n GE         #A555 ;n            :n LT        #B555 ;n
:n GT         #C555 ;n            :n LE        #D555 ;n
:n ALWAYS     #E555 ;n            :n NEVER     #F555 ;n

:n $ains (Br.inst target ) ( Max +-32 kBytes )
        zwo 8 +n -n dup 4 /n vert <0n ( offs. br.inst )
        ja? zwo  2 +n #FF vert ^!n #C000 oder
        dann   vert !n ;n

:n Y?->  $cndxtst weg ;n
:n Y?    #1000 exo $cndxtst
        ja? #A00 $ucf ^!n 0 $lcf !n hier $OC $acdep
        dann ;n
:n TH    hier $OC $ains ;n
:n N:    NEVER Y?  vert TH ;n

:n BEGIN hier $OC ;n
:n END   Y? vert $ains ;n
:n SWI   ( Al Ah ) #FF und #F00 oder $ucf ^!n $lcf !n $acdep ;n
:n JMP/L #1000 exo Y? #100 zwo 2 +n ^!n vert $ains  ;n

( SYSTEM INTERFACE TO JRM'S M-9097 IPS ENGINE AND THUS IPS-M )
( REGISTER ALOCATIONS )
12 kon PPC  ( IPS PSEUDO PROGRAM COUNTER )
11 kon HP
10 kon PS
9  kon RS
8  kon BASE-ADDRESS

( NOT EXPLICITLY NAMED REGISTERS )
( 0 - 6  GENERAL PURPOSE )
( 7   LOOP )
( 13  ARM-STACK )
( 14  LINK-HOLD )
( 15  ARM-PC AND STATUS - 26 BIT MODE )

:int code  hier dup #3 und >0n ja? #FFFC und 4 +n ( WORD-ALIGN )
                              dann $h !n entrysetup $aflagreset
     ja? hier vert !O
     dann ;n

:n NEXT   14 NS 15  MOV ;n   (  MOV PC,R14 )

( COPROCESSOR #15 INSTRUCTIONS )
( R->C15 CORRESPONDS TO MCR, C15->R CORRESPONDS MRC )
( FORMAT: CRn CRm Rd OPC_2 Instr. )

:n R->C15  32 *n vert #1000 *n oder #F10 oder oder $lcf !n
          #F und #E00 oder $ucf ^!n $acdep ;n
:n C15->R  #10 $ucf ^!n R->C15 ;n


( END OF ARM-ASSEMBLER )

 0 kon r0    1 kon r1    2 kon r2    3 kon r3
 4 kon r4    5 kon r5    6 kon r6    7 kon r7

            13 kon r13  14 kon r14  15 kon r15

( "Assembler" definitions for use by IPS-X cross compiler )

  :prior i>      0 compileflag !b ;n
  :int   <i      1 compileflag !b ;n
  :n ,           hier $OC  !b $h incr ;n
  :int rcode
        hier dup #3 und >0n ja? #FFFC und 4 +n ( WORD-ALIGN )
                            dann
        $h !n entrysetup $aflagreset  ja? !O dann ;n
